/*
    Copyright 2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include "rotor.c"



#define VER     "0.1"



void std_err(void);



int main(int argc, char *argv[]) {
    Rotorobj        *rt;
    FILE            *fd;
    int             len;
    unsigned char   buff[128];


    setbuf(stdout, NULL);

    fputs("\n"
        "Blade of Darkness gore password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <Password.txt>\n"
            "\n"
            "Password.txt is located in the Bin folder of the game\n"
            "\n", argv[0]);
        exit(1);
    }

    printf("- open file:     %s\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();
    len = fread(buff, 1, sizeof(buff) - 1, fd);
    fclose(fd);
    buff[len] = 0;

    rt = rotorobj_new(12, "key");

    printf("\n  Gore password: %s\n\n",
        rotorobj_decrypt(rt, buff));

    rotor_dealloc(rt);
    fputs("\n  press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void std_err(void) {
    perror("\nError");
    fputs("\n  press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


